Index: code/branches/ogre/src/core/BaseObject.cc
===================================================================
--- code/branches/ogre/src/core/BaseObject.cc	(revision 1259)
+++ code/branches/ogre/src/core/BaseObject.cc	(revision 1260)
@@ -45,12 +45,11 @@
         @brief Constructor: Registers the object in the BaseObject-list.
     */
-    BaseObject::BaseObject()
+    BaseObject::BaseObject() :
+      bActive_(true),
+      bVisible_(true),
+      level_(0),
+      namespace_(0)
     {
         RegisterRootObject(BaseObject);
-
-        this->bActive_ = true;
-        this->bVisible_ = true;
-        this->level_ = 0;
-        this->namespace_ = 0;
     }
 
Index: code/branches/ogre/src/core/Error.cc
===================================================================
--- code/branches/ogre/src/core/Error.cc	(revision 1259)
+++ code/branches/ogre/src/core/Error.cc	(revision 1260)
@@ -37,15 +37,5 @@
 namespace orxonox
 {
-	Error::Error()
-	{
-		Error(0,"");
-	}
-
 	Error::Error(std::string errorMsg, int errorCode)
-	{
-		Error(errorCode, errorMsg);
-	}
-
-	Error::Error(int errorCode, std::string errorMsg)
 	{
 		COUT(1) << "############################ "<< std::endl
Index: code/branches/ogre/src/core/Error.h
===================================================================
--- code/branches/ogre/src/core/Error.h	(revision 1259)
+++ code/branches/ogre/src/core/Error.h	(revision 1260)
@@ -44,7 +44,5 @@
 	{
 	public:
-		Error();
-		Error(std::string errorMsg, int errorCode = 0);
-		Error(int errorCode, std::string errorMsg = "");
+		Error(std::string errorMsg = "", int errorCode = 0);
 	private:
 
Index: code/branches/ogre/src/core/Namespace.cc
===================================================================
--- code/branches/ogre/src/core/Namespace.cc	(revision 1259)
+++ code/branches/ogre/src/core/Namespace.cc	(revision 1260)
@@ -37,11 +37,10 @@
     CreateFactory(Namespace);
 
-    Namespace::Namespace()
+    Namespace::Namespace() :
+      bAutogeneratedFileRootNamespace_(false),
+      bRoot_(false),
+      operator_("or")
     {
         RegisterObject(Namespace);
-
-        this->bAutogeneratedFileRootNamespace_ = false;
-        this->bRoot_ = false;
-        this->operator_ = "or";
     }
 
Index: code/branches/ogre/src/core/OrxonoxClass.cc
===================================================================
--- code/branches/ogre/src/core/OrxonoxClass.cc	(revision 1259)
+++ code/branches/ogre/src/core/OrxonoxClass.cc	(revision 1260)
@@ -37,10 +37,9 @@
 {
     /** @brief Constructor: Sets the default values. */
-    OrxonoxClass::OrxonoxClass()
+    OrxonoxClass::OrxonoxClass() :
+      identifier_(0),
+      parents_(0)
     {
         this->setConfigValues();
-
-        this->identifier_ = 0;
-        this->parents_ = 0;
     }
 
Index: code/branches/ogre/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/branches/ogre/src/orxonox/GraphicsEngine.cc	(revision 1259)
+++ code/branches/ogre/src/orxonox/GraphicsEngine.cc	(revision 1260)
@@ -44,4 +44,5 @@
 #include "core/ConfigValueIncludes.h"
 #include "core/Debug.h"
+#include "core/CommandExecutor.h"
 
 
@@ -138,6 +139,6 @@
     // create a logManager
     Ogre::LogManager *logger;
-		if (Ogre::LogManager::getSingletonPtr() == 0)
-			logger = new Ogre::LogManager();
+    if (Ogre::LogManager::getSingletonPtr() == 0)
+      logger = new Ogre::LogManager();
     else
       logger = Ogre::LogManager::getSingletonPtr();
@@ -222,9 +223,9 @@
     {
       Ogre::ResourceGroupManager::getSingleton().initialiseAllResourceGroups();
-      Ogre::StringVector str = Ogre::ResourceGroupManager::getSingleton().getResourceGroups();
+      /*Ogre::StringVector str = Ogre::ResourceGroupManager::getSingleton().getResourceGroups();
       for (unsigned int i = 0; i < str.size(); i++)
       {
         Ogre::ResourceGroupManager::getSingleton().loadResourceGroup(str[i]);
-      }
+      }*/
     }
     catch (Ogre::Exception e)
@@ -325,20 +326,44 @@
   }
 
-    void GraphicsEngine::windowMoved(Ogre::RenderWindow *rw){
-        int w = rw->getWidth();
-        int h = rw->getHeight();
-        InputManager::setWindowExtents(w, h);
-    }
-
-    void GraphicsEngine::windowResized(Ogre::RenderWindow *rw){
-        int w = rw->getWidth();
-        int h = rw->getHeight();
-        InputManager::setWindowExtents(w, h);
-    }
-
-    void GraphicsEngine::windowFocusChanged(Ogre::RenderWindow *rw){
-        int w = rw->getWidth();
-        int h = rw->getHeight();
-        InputManager::setWindowExtents(w, h);
-    }
+  /**
+  * Window has resized.
+  * @param rw The render window it occured in
+  */
+  void GraphicsEngine::windowMoved(Ogre::RenderWindow *rw)
+  {
+    // note: this doesn't change the window extents
+  }
+
+  /**
+  * Window has resized.
+  * @param rw The render window it occured in
+  * @note GraphicsEngine has a render window stored itself. This is the same
+  *       as rw. But we have to be careful when using multiple render windows!
+  */
+  void GraphicsEngine::windowResized(Ogre::RenderWindow *rw)
+  {
+    // change the mouse clipping size for absolute mouse movements
+    int w = rw->getWidth();
+    int h = rw->getHeight();
+    InputManager::setWindowExtents(w, h);
+  }
+
+  /**
+  * Window has resized.
+  * @param rw The render window it occured in
+  */
+  void GraphicsEngine::windowFocusChanged(Ogre::RenderWindow *rw)
+  {
+    // note: this doesn't change the window extents
+  }
+
+  /**
+  * Window has resized.
+  * @param rw The render window it occured in
+  */
+  void GraphicsEngine::windowClosed(Ogre::RenderWindow *rw)
+  {
+    // using CommandExecutor in order to avoid depending on Orxonox class.
+    CommandExecutor::execute("exit", false);
+  }
 }
Index: code/branches/ogre/src/orxonox/GraphicsEngine.h
===================================================================
--- code/branches/ogre/src/orxonox/GraphicsEngine.h	(revision 1259)
+++ code/branches/ogre/src/orxonox/GraphicsEngine.h	(revision 1260)
@@ -73,7 +73,8 @@
             int getWindowHeight() const;
 
-            void windowMoved(Ogre::RenderWindow* rw);
-            void windowResized(Ogre::RenderWindow* rw);
+            void windowMoved       (Ogre::RenderWindow* rw);
+            void windowResized     (Ogre::RenderWindow* rw);
             void windowFocusChanged(Ogre::RenderWindow* rw);
+            void windowClosed      (Ogre::RenderWindow* rw);
 
             static GraphicsEngine& getSingleton();
Index: code/branches/ogre/src/orxonox/OrxonoxPlatform.h
===================================================================
--- code/branches/ogre/src/orxonox/OrxonoxPlatform.h	(revision 1259)
+++ code/branches/ogre/src/orxonox/OrxonoxPlatform.h	(revision 1260)
@@ -21,5 +21,5 @@
  *
  *   Author:
- *      An unknown man from the Ogre development crew
+ *      ...
  *   Co-authors:
  *      Reto Grieder
Index: code/branches/ogre/src/orxonox/objects/Explosion.cc
===================================================================
--- code/branches/ogre/src/orxonox/objects/Explosion.cc	(revision 1259)
+++ code/branches/ogre/src/orxonox/objects/Explosion.cc	(revision 1260)
@@ -45,9 +45,8 @@
     CreateFactory(Explosion);
 
-    Explosion::Explosion(WorldEntity* owner)
+    Explosion::Explosion(WorldEntity* owner) :
+      particle_(0),
+      lifetime_(0.4)
     {
-        this->particle_ = 0;
-        this->lifetime_ = 0.4;
-
         RegisterObject(Explosion);
 
Index: code/branches/ogre/src/orxonox/objects/Model.cc
===================================================================
--- code/branches/ogre/src/orxonox/objects/Model.cc	(revision 1259)
+++ code/branches/ogre/src/orxonox/objects/Model.cc	(revision 1260)
@@ -49,15 +49,4 @@
     }
 
-    void Model::loadParams(TiXmlElement* xmlElem)
-    {
-        WorldEntity::loadParams(xmlElem);
-
-        if (xmlElem->Attribute("mesh"))
-        {
-            meshSrc_ = xmlElem->Attribute("mesh");
-        }
-        create();
-    }
-
     /**
         @brief XML loading and saving.
Index: code/branches/ogre/src/orxonox/objects/Model.h
===================================================================
--- code/branches/ogre/src/orxonox/objects/Model.h	(revision 1259)
+++ code/branches/ogre/src/orxonox/objects/Model.h	(revision 1260)
@@ -43,5 +43,4 @@
             Model();
             virtual ~Model();
-            virtual void loadParams(TiXmlElement* xmlElem);
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
             void setMesh(const std::string& meshname);
Index: code/branches/ogre/src/orxonox/objects/NPC.cc
===================================================================
--- code/branches/ogre/src/orxonox/objects/NPC.cc	(revision 1259)
+++ code/branches/ogre/src/orxonox/objects/NPC.cc	(revision 1260)
@@ -36,8 +36,8 @@
   CreateFactory(NPC);
 
-  NPC::NPC()
+  NPC::NPC() :
+    movable_(true)
   {
     RegisterObject(NPC);
-    movable_ = true;
   }
 
Index: code/branches/ogre/src/orxonox/objects/Projectile.cc
===================================================================
--- code/branches/ogre/src/orxonox/objects/Projectile.cc	(revision 1259)
+++ code/branches/ogre/src/orxonox/objects/Projectile.cc	(revision 1260)
@@ -42,11 +42,10 @@
     CreateFactory(Projectile);
 
-    Projectile::Projectile(SpaceShip* owner)
+    Projectile::Projectile(SpaceShip* owner) :
+      owner_(owner)
     {
         RegisterObject(Projectile);
 
         this->setConfigValues();
-
-        this->owner_ = owner;
 
         this->billboard_.setBillboardSet("Examples/Flare", ColourValue(1.0, 1.0, 0.5), 1);
Index: code/branches/ogre/src/orxonox/objects/WorldEntity.cc
===================================================================
--- code/branches/ogre/src/orxonox/objects/WorldEntity.cc	(revision 1259)
+++ code/branches/ogre/src/orxonox/objects/WorldEntity.cc	(revision 1260)
@@ -45,13 +45,13 @@
     unsigned int WorldEntity::worldEntityCounter_s = 0;
 
-    WorldEntity::WorldEntity()
+    WorldEntity::WorldEntity() :
+      velocity_    (0, 0, 0),
+      acceleration_(0, 0, 0),
+      rotationAxis_(0, 1, 0),
+      rotationRate_(0),
+      momentum_    (0),
+      node_        (0),
+      bStatic_     (true)
     {
-        this->bStatic_ = true;
-        this->velocity_ = Vector3(0, 0, 0);
-        this->acceleration_ = Vector3(0, 0, 0);
-        this->rotationAxis_ = Vector3(0, 1, 0);
-        this->rotationRate_ = 0;
-        this->momentum_ = 0;
-
         RegisterObject(WorldEntity);
 
@@ -64,8 +64,4 @@
 
           registerAllVariables();
-        }
-        else
-        {
-          this->node_ = 0;
         }
     }
@@ -92,71 +88,4 @@
         BaseObject::loadParams(xmlElem);
         create();
-/*
-        if (xmlElem->Attribute("position"))
-        {
-            std::vector<std::string> pos = tokenize(xmlElem->Attribute("position"),",");
-            float x, y, z;
-            String2Number<float>(x, pos[0]);
-            String2Number<float>(y, pos[1]);
-            String2Number<float>(z, pos[2]);
-            this->setPosition(x, y, z);
-        }
-
-        if (xmlElem->Attribute("direction"))
-        {
-            std::vector<std::string> pos = tokenize(xmlElem->Attribute("direction"),",");
-            float x, y, z;
-            String2Number<float>(x, pos[0]);
-            String2Number<float>(y, pos[1]);
-            String2Number<float>(z, pos[2]);
-            this->setDirection(x, y, z);
-        }
-
-        if (xmlElem->Attribute("yaw") || xmlElem->Attribute("pitch") || xmlElem->Attribute("roll"))
-        {
-            float yaw = 0.0, pitch = 0.0, roll = 0.0;
-            if (xmlElem->Attribute("yaw"))
-                String2Number<float>(yaw,xmlElem->Attribute("yaw"));
-
-            if (xmlElem->Attribute("pitch"))
-                String2Number<float>(pitch,xmlElem->Attribute("pitch"));
-
-            if (xmlElem->Attribute("roll"))
-                String2Number<float>(roll,xmlElem->Attribute("roll"));
-
-            this->yaw(Degree(yaw));
-            this->pitch(Degree(pitch));
-            this->roll(Degree(roll));
-        }
-
-        if (xmlElem->Attribute("scale"))
-        {
-            std::string scaleStr = xmlElem->Attribute("scale");
-            float scale;
-            String2Number<float>(scale, scaleStr);
-            this->setScale(scale);
-        }
-
-        if (xmlElem->Attribute("rotationAxis"))
-        {
-            std::vector<std::string> pos = tokenize(xmlElem->Attribute("rotationAxis"),",");
-            float x, y, z;
-            String2Number<float>(x, pos[0]);
-            String2Number<float>(y, pos[1]);
-            String2Number<float>(z, pos[2]);
-            this->setRotationAxis(x, y, z);
-        }
-
-        if (xmlElem->Attribute("rotationRate"))
-        {
-            float rotationRate;
-            String2Number<float>(rotationRate, xmlElem->Attribute("rotationRate"));
-            this->setRotationRate(Degree(rotationRate));
-            if (rotationRate != 0)
-                this->setStatic(false);
-        }
-
-        create();
-*/
     }
 