Index: code/branches/merge/src/network/GameStateManager.cc
===================================================================
--- code/branches/merge/src/network/GameStateManager.cc	(revision 1264)
+++ code/branches/merge/src/network/GameStateManager.cc	(revision 1265)
@@ -442,4 +442,5 @@
     }
     COUT(4) << std::endl;
+    return true;
   }
   
Index: code/branches/merge/src/orxonox/objects/SpaceShip.cc
===================================================================
--- code/branches/merge/src/orxonox/objects/SpaceShip.cc	(revision 1264)
+++ code/branches/merge/src/orxonox/objects/SpaceShip.cc	(revision 1265)
@@ -64,5 +64,38 @@
     SpaceShip* SpaceShip::instance_s;
 
-    SpaceShip::SpaceShip()
+    SpaceShip::SpaceShip() :
+      //testvector_(0,0,0),
+      //bInvertYAxis_(false),
+      setMouseEventCallback_(false),
+      bLMousePressed_(false),
+      bRMousePressed_(false),
+      camNode_(0),
+      cam_(0),
+      camName_("CamNode"),
+      tt_(0),
+      greenNode_(0),
+      redNode_(0),
+      blinkTime_(0.0f),
+      chNearNode_(0),
+      chFarNode_(0),
+      timeToReload_(0.0f),
+      //reloadTime_(0.0f),
+      maxSideAndBackSpeed_(0.0f),
+      maxSpeed_(0.0f),
+      maxRotation_(0.0f),
+      translationAcceleration_(0.0f),
+      rotationAcceleration_(0.0f),
+      translationDamping_(0.0f),
+      rotationDamping_(0.0f),
+      maxRotationRadian_(0),
+      rotationAccelerationRadian_(0),
+      rotationDampingRadian_(0),
+      zeroRadian_(0),
+      mouseXRotation_(0),
+      mouseYRotation_(0),
+      mouseX_(0.0f),
+      mouseY_(0.0f),
+      emitterRate_(0.0f),
+      server_(false)
     {
         RegisterObject(SpaceShip);
@@ -73,38 +106,6 @@
         this->setConfigValues();
 
-        this->setMouseEventCallback_ = false;
-        this->bLMousePressed_ = false;
-        this->bRMousePressed_ = false;
-        this->mouseX_ = 0;
-        this->mouseY_ = 0;
-
-        this->camNode_ = 0;
-        this->camName_ = "camNode";
-
-        this->tt_ = 0;
-        this->redNode_ = 0;
-        this->greenNode_ = 0;
-        this->blinkTime_ = 0;
-
-        this->timeToReload_ = 0;
-
-        this->maxSpeed_ = 0;
-        this->maxSideAndBackSpeed_ = 0;
-        this->maxRotation_ = 0;
-        this->translationAcceleration_ = 0;
-        this->rotationAcceleration_ = 0;
-        this->translationDamping_ = 0;
-        this->rotationDamping_ = 0;
-
-        this->maxRotationRadian_ = 0;
-        this->rotationAccelerationRadian_ = 0;
-        this->rotationDampingRadian_ = 0;
-        this->zeroRadian_ = Radian(0);
-
         this->setRotationAxis(1, 0, 0);
         this->setStatic(false);
-
-        server_=false;
-
 
         COUT(3) << "Info: SpaceShip was loaded" << std::endl;
Index: code/branches/merge/visual_studio/network_properties.vsprops
===================================================================
--- code/branches/merge/visual_studio/network_properties.vsprops	(revision 1264)
+++ code/branches/merge/visual_studio/network_properties.vsprops	(revision 1265)
@@ -8,5 +8,5 @@
 	<Tool
 		Name="VCCLCompilerTool"
-		PreprocessorDefinitions="NETWORK_SHARED_BUILD;WIN32_LEAN_AND_MEAN"
+		PreprocessorDefinitions="NETWORK_STATIC_BUILD;WIN32_LEAN_AND_MEAN"
 	/>
 	<Tool
Index: code/branches/merge/visual_studio/orxonox_properties.vsprops
===================================================================
--- code/branches/merge/visual_studio/orxonox_properties.vsprops	(revision 1264)
+++ code/branches/merge/visual_studio/orxonox_properties.vsprops	(revision 1265)
@@ -8,5 +8,5 @@
 	<Tool
 		Name="VCCLCompilerTool"
-		PreprocessorDefinitions="ORXONOX_SHARED_BUILD"
+		PreprocessorDefinitions="ORXONOX_SHARED_BUILD;NETWORK_STATIC_BUILD"
 		UsePrecompiledHeader="2"
 		PrecompiledHeaderThrough="OrxonoxStableHeaders.h"
@@ -14,7 +14,7 @@
 	<Tool
 		Name="VCLinkerTool"
-		AdditionalDependencies="OgreMain$(CSS).lib tcl85t.lib"
+		AdditionalDependencies="OgreMain$(CSS).lib tcl85t.lib enet$(CS).lib zlib$(CS).lib"
 		OutputFile="$(OutDir)$(ProjectName)$(CS).exe"
-		IgnoreDefaultLibraryNames=""
+		IgnoreDefaultLibraryNames="LIBCMT;LIBCMTD"
 	/>
 </VisualStudioPropertySheet>
Index: code/branches/merge/visual_studio/vc8/network.vcproj
===================================================================
--- code/branches/merge/visual_studio/vc8/network.vcproj	(revision 1264)
+++ code/branches/merge/visual_studio/vc8/network.vcproj	(revision 1265)
@@ -18,5 +18,5 @@
 		<Configuration
 			Name="Debug|Win32"
-			ConfigurationType="2"
+			ConfigurationType="4"
 			InheritedPropertySheets="$(SolutionDir)base_properties_debug.vsprops;..\network_properties.vsprops"
 			CharacterSet="1"
@@ -50,5 +50,5 @@
 			/>
 			<Tool
-				Name="VCLinkerTool"
+				Name="VCLibrarianTool"
 			/>
 			<Tool
@@ -56,7 +56,4 @@
 			/>
 			<Tool
-				Name="VCManifestTool"
-			/>
-			<Tool
 				Name="VCXDCMakeTool"
 			/>
@@ -66,10 +63,4 @@
 			<Tool
 				Name="VCFxCopTool"
-			/>
-			<Tool
-				Name="VCAppVerifierTool"
-			/>
-			<Tool
-				Name="VCWebDeploymentTool"
 			/>
 			<Tool
Index: code/branches/merge/visual_studio/vc8/orxonox.vcproj
===================================================================
--- code/branches/merge/visual_studio/vc8/orxonox.vcproj	(revision 1264)
+++ code/branches/merge/visual_studio/vc8/orxonox.vcproj	(revision 1265)
@@ -204,4 +204,8 @@
 				</File>
 				<File
+					RelativePath="..\..\src\orxonox\objects\CameraHandler.cc"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\orxonox\objects\Explosion.cc"
 					>
@@ -459,4 +463,8 @@
 				<File
 					RelativePath="..\..\src\orxonox\objects\Camera.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\orxonox\objects\CameraHandler.h"
 					>
 				</File>