Index: code/branches/merge/src/core/InputHandler.cc
===================================================================
--- code/branches/merge/src/core/InputHandler.cc	(revision 1266)
+++ code/branches/merge/src/core/InputHandler.cc	(revision 1268)
@@ -55,173 +55,173 @@
     std::string keyNames[] = {
     "UNASSIGNED",
-		"ESCAPE",
-		"1",
-		"2",
-		"3",
-		"4",
-		"5",
-		"6",
-		"7",
-		"8",
-		"9",
-		"0",
-		"MINUS",
-		"EQUALS",
-		"BACK",
-		"TAB",
-		"Q",
-		"W",
-		"E",
-		"R",
-		"T",
-		"Y",
-		"U",
-		"I",
-		"O",
-		"P",
-		"LBRACKET",
-		"RBRACKET",
-		"RETURN",
-		"LCONTROL",
-		"A",
-		"S",
-		"D",
-		"F",
-		"G",
-		"H",
-		"J",
-		"K",
-		"L",
-		"SEMICOLON",
-		"APOSTROPHE",
-		"GRAVE",
-		"LSHIFT",
-		"BACKSLASH",
-		"Z",
-		"X",
-		"C",
-		"V",
-		"B",
-		"N",
-		"M",
-		"COMMA",
-		"PERIOD",
-		"SLASH",
-		"RSHIFT",
-		"MULTIPLY",
-		"LMENU",
-		"SPACE",
-		"CAPITAL",
-		"F1",
-		"F2",
-		"F3",
-		"F4",
-		"F5",
-		"F6",
-		"F7",
-		"F8",
-		"F9",
-		"F10",
-		"NUMLOCK",
-		"SCROLL",
-		"NUMPAD7",
-		"NUMPAD8",
-		"NUMPAD9",
-		"SUBTRACT",
-		"NUMPAD4",
-		"NUMPAD5",
-		"NUMPAD6",
-		"ADD",
-		"NUMPAD1",
-		"NUMPAD2",
-		"NUMPAD3",
-		"NUMPAD0",
-		"DECIMAL",
+    "ESCAPE",
+    "1",
+    "2",
+    "3",
+    "4",
+    "5",
+    "6",
+    "7",
+    "8",
+    "9",
+    "0",
+    "MINUS",
+    "EQUALS",
+    "BACK",
+    "TAB",
+    "Q",
+    "W",
+    "E",
+    "R",
+    "T",
+    "Y",
+    "U",
+    "I",
+    "O",
+    "P",
+    "LBRACKET",
+    "RBRACKET",
+    "RETURN",
+    "LCONTROL",
+    "A",
+    "S",
+    "D",
+    "F",
+    "G",
+    "H",
+    "J",
+    "K",
+    "L",
+    "SEMICOLON",
+    "APOSTROPHE",
+    "GRAVE",
+    "LSHIFT",
+    "BACKSLASH",
+    "Z",
+    "X",
+    "C",
+    "V",
+    "B",
+    "N",
+    "M",
+    "COMMA",
+    "PERIOD",
+    "SLASH",
+    "RSHIFT",
+    "MULTIPLY",
+    "LMENU",
+    "SPACE",
+    "CAPITAL",
+    "F1",
+    "F2",
+    "F3",
+    "F4",
+    "F5",
+    "F6",
+    "F7",
+    "F8",
+    "F9",
+    "F10",
+    "NUMLOCK",
+    "SCROLL",
+    "NUMPAD7",
+    "NUMPAD8",
+    "NUMPAD9",
+    "SUBTRACT",
+    "NUMPAD4",
+    "NUMPAD5",
+    "NUMPAD6",
+    "ADD",
+    "NUMPAD1",
+    "NUMPAD2",
+    "NUMPAD3",
+    "NUMPAD0",
+    "DECIMAL",
     "","",
-		"OEM_102",
-		"F11",
-		"F12",
+    "OEM_102",
+    "F11",
+    "F12",
     "","","","","","","","","","","",
-		"F13",
-		"F14",
-		"F15",
+    "F13",
+    "F14",
+    "F15",
     "","","","","","","","","","",
-		"KANA",
+    "KANA",
     "","",
-		"ABNT_C1",
+    "ABNT_C1",
     "","","","","",
-		"CONVERT",
-    "",
-		"NOCONVERT",
-    "",
-		"YEN",
-		"ABNT_C2",
+    "CONVERT",
+    "",
+    "NOCONVERT",
+    "",
+    "YEN",
+    "ABNT_C2",
     "","","","","","","","","","","","","","",
-		"NUMPADEQUALS",
+    "NUMPADEQUALS",
     "","",
-		"PREVTRACK",
-		"AT",
-		"COLON",
-		"UNDERLINE",
-		"KANJI",
-		"STOP",
-		"AX",
-		"UNLABELED",
-		"NEXTTRACK",
+    "PREVTRACK",
+    "AT",
+    "COLON",
+    "UNDERLINE",
+    "KANJI",
+    "STOP",
+    "AX",
+    "UNLABELED",
+    "NEXTTRACK",
     "","",
-		"NUMPADENTER",
-		"RCONTROL",
+    "NUMPADENTER",
+    "RCONTROL",
     "","",
-		"MUTE",
-		"CALCULATOR",
-		"PLAYPAUSE",
-    "",
-		"MEDIASTOP",
+    "MUTE",
+    "CALCULATOR",
+    "PLAYPAUSE",
+    "",
+    "MEDIASTOP",
     "","","","","","","","","",
-		"VOLUMEDOWN",
-    "",
-		"VOLUMEUP",
-    "",
-		"WEBHOME",
-		"NUMPADCOMMA",
-    "",
-		"DIVIDE",
-    "",
-		"SYSRQ",
-		"RMENU",
+    "VOLUMEDOWN",
+    "",
+    "VOLUMEUP",
+    "",
+    "WEBHOME",
+    "NUMPADCOMMA",
+    "",
+    "DIVIDE",
+    "",
+    "SYSRQ",
+    "RMENU",
     "","","","","","","","","","","","",
-		"PAUSE",
-    "",
-		"HOME",
-		"UP",
-		"PGUP",
-    "",
-		"LEFT",
-    "",
-		"RIGHT",
-    "",
-		"END",
-		"DOWN",
-		"PGDOWN",
-		"INSERT",
-		"DELETE",
+    "PAUSE",
+    "",
+    "HOME",
+    "UP",
+    "PGUP",
+    "",
+    "LEFT",
+    "",
+    "RIGHT",
+    "",
+    "END",
+    "DOWN",
+    "PGDOWN",
+    "INSERT",
+    "DELETE",
     "","","","","","","",
-		"LWIN",
-		"RWIN",
-		"APPS",
-		"POWER",
-		"SLEEP",
+    "LWIN",
+    "RWIN",
+    "APPS",
+    "POWER",
+    "SLEEP",
     "","","",
-		"WAKE",
-    "",
-		"WEBSEARCH",
-		"WEBFAVORITES",
-		"WEBREFRESH",
-		"WEBSTOP",
-		"WEBFORWARD",
-		"WEBBACK",
-		"MYCOMPUTER",
-		"MAIL",
-		"MEDIASELECT"
+    "WAKE",
+    "",
+    "WEBSEARCH",
+    "WEBFAVORITES",
+    "WEBREFRESH",
+    "WEBSTOP",
+    "WEBFORWARD",
+    "WEBBACK",
+    "MYCOMPUTER",
+    "MAIL",
+    "MEDIASELECT"
     };
     for (int i = 0; i < numberOfKeys_s; i++)
@@ -229,7 +229,7 @@
 
     std::string mouseButtonNames[] = {
-    "MouseLeft", "MouseRight", "MouseMiddle",
-    "MouseButton3", "MouseButton4", "MouseButton5",
-    "MouseButton6", "MouseButton7" };
+      "MouseLeft", "MouseRight", "MouseMiddle",
+      "MouseButton3", "MouseButton4", "MouseButton5",
+      "MouseButton6", "MouseButton7" };
     for (int i = 0; i < numberOfMouseButtons_s; i++)
       mouseButtonNames_[i] = mouseButtonNames[i];
@@ -393,5 +393,5 @@
       //  binding.commandStr = binding.evaluation.getCommandString();
       //}
-      COUT(3) << "Executing command: " << binding.commandStr << std::endl;
+      COUT(ORX_DEBUG) << "Keybinding: Executing command: " << binding.commandStr << std::endl;
       CommandExecutor::execute(binding.commandStr);
     }
@@ -407,5 +407,5 @@
   bool KeyBinder::keyPressed(const OIS::KeyEvent &e)
   {
-    COUT(3) << "Key: " << e.key << std::endl;
+    //COUT(ORX_DEBUG) << "Key: " << e.key << std::endl;
     // find the appropriate key binding
     executeBinding(bindingsKeyPress_[int(e.key)]);
@@ -459,5 +459,5 @@
     {
       CommandExecutor::execute(cmdStr);
-      COUT(3) << "Executing command: " << cmdStr << std::endl;
+      //COUT(3) << "Executing command: " << cmdStr << std::endl;
     }
 
@@ -477,5 +477,5 @@
     {
       CommandExecutor::execute(cmdStr);
-      COUT(3) << "Executing command: " << cmdStr << std::endl;
+      //COUT(3) << "Executing command: " << cmdStr << std::endl;
     }
 
@@ -495,5 +495,5 @@
     {
       CommandExecutor::execute(cmdStr);
-      COUT(3) << "Executing command: " << cmdStr << std::endl;
+      //COUT(3) << "Executing command: " << cmdStr << std::endl;
     }
 
@@ -508,5 +508,5 @@
     {
       CommandExecutor::execute(cmdStr);
-      COUT(3) << "Executing command: " << cmdStr << std::endl;
+      //COUT(3) << "Executing command: " << cmdStr << std::endl;
     }
 
@@ -521,5 +521,5 @@
     {
       CommandExecutor::execute(cmdStr);
-      COUT(3) << "Executing command: " << cmdStr << std::endl;
+      //COUT(3) << "Executing command: " << cmdStr << std::endl;
     }
 
@@ -534,5 +534,5 @@
     {
       CommandExecutor::execute(cmdStr);
-      COUT(3) << "Executing command: " << cmdStr << std::endl;
+      //COUT(3) << "Executing command: " << cmdStr << std::endl;
     }
 
@@ -586,6 +586,6 @@
   //bool GUIInputHandler::keyPressed(const OIS::KeyEvent &e)
   //{
-		////CEGUI::System::getSingleton().injectKeyDown( arg.key );
-		////CEGUI::System::getSingleton().injectChar( arg.text );
+    ////CEGUI::System::getSingleton().injectKeyDown( arg.key );
+    ////CEGUI::System::getSingleton().injectChar( arg.text );
   //  return true;
   //}
@@ -597,5 +597,5 @@
   //bool GUIInputHandler::keyReleased(const OIS::KeyEvent &e)
   //{
-		////CEGUI::System::getSingleton().injectKeyUp( arg.key );
+    ////CEGUI::System::getSingleton().injectKeyUp( arg.key );
   //  return true;
   //}
@@ -607,5 +607,5 @@
   //bool GUIInputHandler::mouseMoved(const OIS::MouseEvent &e)
   //{
-		////CEGUI::System::getSingleton().injectMouseMove( arg.state.X.rel, arg.state.Y.rel );
+    ////CEGUI::System::getSingleton().injectMouseMove( arg.state.X.rel, arg.state.Y.rel );
   //  return true;
   //}
@@ -618,5 +618,5 @@
   //bool GUIInputHandler::mousePressed(const OIS::MouseEvent &e, OIS::MouseButtonID id)
   //{
-		////CEGUI::System::getSingleton().injectMouseButtonDown(convertOISMouseButtonToCegui(id));
+    ////CEGUI::System::getSingleton().injectMouseButtonDown(convertOISMouseButtonToCegui(id));
   //  return true;
   //}
@@ -629,5 +629,5 @@
   //bool GUIInputHandler::mouseReleased(const OIS::MouseEvent &e, OIS::MouseButtonID id)
   //{
-		////CEGUI::System::getSingleton().injectMouseButtonUp(convertOISMouseButtonToCegui(id));
+    ////CEGUI::System::getSingleton().injectMouseButtonUp(convertOISMouseButtonToCegui(id));
   //  return true;
   //}
Index: code/branches/merge/src/core/InputManager.cc
===================================================================
--- code/branches/merge/src/core/InputManager.cc	(revision 1266)
+++ code/branches/merge/src/core/InputManager.cc	(revision 1268)
@@ -92,4 +92,5 @@
     if (state_ == IS_UNINIT)
     {
+      CCOUT(3) << "Initialising Input System..." << std::endl;
       CCOUT(ORX_DEBUG) << "Initialising OIS components..." << std::endl;
 
Index: code/branches/merge/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/branches/merge/src/orxonox/GraphicsEngine.cc	(revision 1266)
+++ code/branches/merge/src/orxonox/GraphicsEngine.cc	(revision 1268)
@@ -99,5 +99,5 @@
   void GraphicsEngine::destroy()
   {
-    COUT(4) << "Destroying objects..." << std::endl;
+    CCOUT(4) << "Destroying objects..." << std::endl;
     Ogre::WindowEventUtilities::removeWindowEventListener(this->renderWindow_, this);
     if (this->root_)
@@ -113,5 +113,5 @@
       delete Ogre::LogManager::getSingletonPtr();
     }
-    COUT(4) << "Destroying objects done" << std::endl;
+    CCOUT(4) << "Destroying objects done" << std::endl;
   }
 
@@ -139,8 +139,10 @@
     // create a logManager
     Ogre::LogManager *logger;
-    if (Ogre::LogManager::getSingletonPtr() == 0)
-      logger = new Ogre::LogManager();
-    else
-      logger = Ogre::LogManager::getSingletonPtr();
+    //if (Ogre::LogManager::getSingletonPtr() == 0)
+    // note: If there's already a logManager, Ogre will complain by a failed assertation.
+    // but that shouldn't happen, since this is the first time to create a logManager..
+    logger = new Ogre::LogManager();
+    //else
+    //  logger = Ogre::LogManager::getSingletonPtr();
     CCOUT(4) << "Ogre LogManager created/assigned" << std::endl;
 
@@ -151,5 +153,5 @@
     else
       myLog = logger->createLog(this->ogreLogfile_, true, false, false);
-    COUT(4) << "*** GraphicsEngine: Ogre Log created" << std::endl;
+    CCOUT(4) << "Ogre Log created" << std::endl;
 
     myLog->setLogDetail(Ogre::LL_BOREME);
Index: code/branches/merge/src/orxonox/Orxonox.cc
===================================================================
--- code/branches/merge/src/orxonox/Orxonox.cc	(revision 1266)
+++ code/branches/merge/src/orxonox/Orxonox.cc	(revision 1268)
@@ -201,5 +201,5 @@
   void Orxonox::abortRequest()
   {
-    COUT(3) << "*** Orxonox: Abort requested." << std::endl;
+    COUT(3) << "Orxonox: Abort requested." << std::endl;
     bAbort_ = true;
   }
@@ -246,5 +246,4 @@
       return false;
 
-    COUT(3) << "*** Orxonox: Mode is " << mode << "." << std::endl;
     if (mode == "client")
       mode_ = CLIENT;
@@ -252,5 +251,9 @@
       mode_ = SERVER;
     else
+    {
+      mode = "standalone";
       mode_ = STANDALONE;
+    }
+    COUT(3) << "Orxonox: Mode is " << mode << "." << std::endl;
 
     //if (mode_ == DEDICATED)
@@ -343,5 +346,5 @@
 
     // Load the HUD
-    COUT(3) << "*** Orxonox: Loading HUD..." << std::endl;
+    COUT(3) << "Orxonox: Loading HUD..." << std::endl;
     Ogre::Overlay* hudOverlay = Ogre::OverlayManager::getSingleton().getByName("Orxonox/HUD1.2");
     orxonoxHUD_ = new HUD();
@@ -350,5 +353,5 @@
     hudOverlay->show();
 
-    COUT(3) << "*** Orxonox: Loading Console..." << std::endl;
+    COUT(3) << "Orxonox: Loading Console..." << std::endl;
     InputBuffer* ib = dynamic_cast<InputBuffer*>(InputManager::getKeyHandler("buffer"));
     /*
@@ -445,5 +448,5 @@
     if (Ogre::Root::getSingletonPtr() == 0)
     {
-      COUT(2) << "*** Orxonox Error: Could not start rendering. No Ogre root object found" << std::endl;
+      COUT(2) << "Orxonox Error: Could not start rendering. No Ogre root object found" << std::endl;
       return false;
     }
@@ -466,5 +469,5 @@
     timer_->reset();
 
-    COUT(3) << "*** Orxonox: Starting the main loop." << std::endl;
+    COUT(3) << "Orxonox: Starting the main loop." << std::endl;
 	  while (!bAbort_)
 	  {